{% from "components/plot_div.html.j2" import plot_div %}

{% macro field_card(field_name, field_data, field_plots) %}
<div class="card m-2 m-md-5 shadow">
    <div class="card-header text-center">
        <h4 class="card-title mb-0">{{ field_name }}</h4>
    </div>
    <div class="row">
        <div class="col-12 col-md-6">
            {{ field_card_body(field_name, field_data) }}
        </div>
        <div class="col-12 col-md-6">
            <div id="tabs-{{ field_name|replace(" ", "-") }}">
                <ul>
                    {% for plot in field_plots %}
                    <li><a href="#tab-{{ field_name|replace(" ", "-") }}-{{ loop.index0 }}">{{ plot.plot_type }}</a></li>

                    {% endfor %}
                </ul>
                {% for plot in field_plots %}
                <div id="tab-{{ field_name|replace(" ", "-") }}-{{ loop.index0 }}">
                    {{ plot_div(plot, (field_name ~ loop.index0)|replace(" ", "-")) }}
                </div>
                {% endfor %}
            </div>
        </div>
    </div>



    <script>
        $(function () {
            $("#tabs-{{ field_name|replace(" ", "-") }}").tabs();
        });
    </script>
</div>
{% endmacro %}

{% macro field_card_body(field_name, field_data) %}
<div class="card-body">
    <div class="row">
        {% for key, value in field_data.items() %}
        <div class="col-12 col-md-6">
            {% if value is iterable and value is not string %}
            {{ data_list(key, value) }}
            {% else %}
            {{ data_item(key, value, field_data["Highest Precision"]) }}
            {% endif %}
        </div>
        {% endfor %}
    </div>
</div>
{% endmacro %}

{% macro data_item(key, value, max_precision=0) %}
<p class="card-text">
    <span class="card-key">{{ key }}:</span>
    {% if value is number and max_precision is number %}
    <span class="card-value">{{ "{:.{}g}".format(value, max_precision) }}</span>
    {% elif value is number %}
    <span class="card-value">{{ "{:.2g}".format(value) }}</span>
    {% else %}
    <span class="card-value">{{ value }}</span>
    {% endif %}
</p>
{% endmacro %}

{% macro data_list(key, values) %}
<div class="card-text data-list">
    <span class="card-key">{{ key }}:</span>

    {% if values %}
    <div class="card-value">
        {% for value, count in values %}
        <span>{{ value }}: {{ count }}</span>
        {% endfor %}
    </div>
    {% else %}
    <span>No values available</span>
    {% endif %}

</div>
{% endmacro %}
